<?php
/**
 * Clase Base DP para BaseCrSucursalValidadorDP
 *
 * @package    
 * @subpackage BaseCrSucursalValidadorDP
 * @author     Willy
 * @version    SVN:: BaseCrSucursalValidadorDP.class.php,v 1.1 2022-12-31 10:03:03 william.taype Exp $
 */
abstract class BaseCrSucursalValidadorDP extends CrSucursalValidadorBN
{
  /* N�mero de registros afectados */
  private $nRowsAffected;

  public function __construct($bSetDefault = true)
  {
    if( $bSetDefault instanceof CrSucursalValidadorBN )
    {
      $o_CrSucursalValidadorBN = $bSetDefault;
      if($o_CrSucursalValidadorBN->getIdSucursal()) : $this->setIdSucursal($o_CrSucursalValidadorBN->getIdSucursal()); endif;
      if($o_CrSucursalValidadorBN->getIdColaborador()) : $this->setIdColaborador($o_CrSucursalValidadorBN->getIdColaborador()); endif;
      if($o_CrSucursalValidadorBN->getIdRol()) : $this->setIdRol($o_CrSucursalValidadorBN->getIdRol()); endif;
      if($o_CrSucursalValidadorBN->getEstado()) : $this->setEstado($o_CrSucursalValidadorBN->getEstado()); endif;
      if($o_CrSucursalValidadorBN->getFechaCreacion()) : $this->setFechaCreacion($o_CrSucursalValidadorBN->getFechaCreacion()); endif;
      if($o_CrSucursalValidadorBN->getUsuarioCreacion()) : $this->setUsuarioCreacion($o_CrSucursalValidadorBN->getUsuarioCreacion()); endif;
    }
  }

  /* Obtiene el n�mero de registros afectados */
  public function getRowsAffected()
  {
    return $this->nRowsAffected;
  }

  public function save()
  {
    try
    {
      $con = Conexion::getConexion();
      
      
      if($this->getIdSucursal() && $this->getIdColaborador()){
        $a_Fields = array();

        if($this->getIdSucursal()) : $a_Fields['IdSucursal'] = ($this->getIdSucursal()); endif;
        if($this->getIdColaborador()) : $a_Fields['IdColaborador'] = ($this->getIdColaborador()); endif;
        if($this->getIdRol()) : $a_Fields['IdRol'] = ($this->getIdRol()); endif;
        if($this->getEstado()) : $a_Fields['Estado'] = ($this->getEstado()); endif;
        if($this->getFechaCreacion()) : $a_Fields['FechaCreacion'] = ($this->getFechaCreacion()); endif;
        if($this->getUsuarioCreacion()) : $a_Fields['UsuarioCreacion'] = ($this->getUsuarioCreacion()); endif;

        $sStringField = arrayClass::implode_keys(',', $a_Fields);
        $sStringValue = "'".implode("','", $a_Fields)."'";

        $sql = "INSERT INTO cr_sucursal_validador (".$sStringField.") VALUES (".$sStringValue.");";
        
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
        if($result)
        {
          $this->nRowsAffected = (int) mysql_affected_rows($oLink);
        }
        else
        {
          throw new Exception( mysql_error($oLink) );
        }
      }
      else
      {
        throw new Exception( 'El id no esta registrado.');
      }
    }
    catch ( Exception $o_Error )
    {
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
    return true;
  }

  public function update()
  {
    try
    {
      if($this->getIdSucursal() && $this->getIdColaborador())
      {
        $a_Fields = array();

        if($this->getIdSucursal()) : $a_Fields['IdSucursal'] = ($this->getIdSucursal()); endif;
        if($this->getIdColaborador()) : $a_Fields['IdColaborador'] = ($this->getIdColaborador()); endif;
        if($this->getIdRol()) : $a_Fields['IdRol'] = ($this->getIdRol()); endif;
        if($this->getEstado()) : $a_Fields['Estado'] = ($this->getEstado()); endif;
        if($this->getFechaCreacion()) : $a_Fields['FechaCreacion'] = ($this->getFechaCreacion()); endif;
        if($this->getUsuarioCreacion()) : $a_Fields['UsuarioCreacion'] = ($this->getUsuarioCreacion()); endif;

        $sStringField = arrayClass::implode_key_value(',', $a_Fields);

        $con = Conexion::getConexion();
        $sql = "UPDATE cr_sucursal_validador SET ".$sStringField." WHERE 1 AND IdSucursal='".$this->getIdSucursal()."' AND IdColaborador='".$this->getIdColaborador()."';";
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
        if($result)
        {
          $this->nRowsAffected = (int) mysql_affected_rows($oLink);
        }
        else
        {
          throw new Exception( mysql_error($oLink) );
        }
      }
      else
      {
        throw new Exception( 'El id no esta registrado.');
      }
    }
    catch ( Exception $o_Error )
    {
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
    return true;
  }

  public function delete()
  {
    try
    {
      if($this->getIdSucursal() && $this->getIdColaborador())
      {
        $a_Fields = array();

        $con = Conexion::getConexion();
        $sql = "DELETE FROM cr_sucursal_validador WHERE 1 AND IdSucursal='".$this->getIdSucursal()."' AND IdColaborador='".$this->getIdColaborador()."';"; 
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
        if($result)
        {
          $this->nRowsAffected = (int) mysql_affected_rows($oLink);
        }
        else
        {
          throw new Exception( mysql_error($oLink) );
        }
      }
      else
      {
        throw new Exception( 'El id no esta registrado.');
      }
    }
    catch ( Exception $o_Error )
    {
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
    return true;
  }

  /* B�squeda del registro por la llave primaria */
  public static function selectByPK($vIdSucursal, $vIdColaborador)
  {
    try
    {
      $con = Conexion::getConexion();
      $sql = "SELECT IdSucursal, IdColaborador, IdRol, Estado, FechaCreacion, UsuarioCreacion FROM cr_sucursal_validador WHERE 1 AND IdSucursal='".$vIdSucursal."' AND IdColaborador='".$vIdColaborador."'; ";
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
      $o_Propel = $result ? mysql_fetch_object($result) : null;
      
      return $o_Propel?self::insertObjectBN($o_Propel):null;

    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  /* Devuelve un objeto con m�todos de acceso */
  private function insertObjectBN($o_propel){
    $o_CrSucursalValidadorDP = new CrSucursalValidadorDP();
    $o_CrSucursalValidadorDP->setIdSucursal($o_propel->IdSucursal);
    $o_CrSucursalValidadorDP->setIdColaborador($o_propel->IdColaborador);
    $o_CrSucursalValidadorDP->setIdRol($o_propel->IdRol);
    $o_CrSucursalValidadorDP->setEstado($o_propel->Estado);
    $o_CrSucursalValidadorDP->setFechaCreacion($o_propel->FechaCreacion);
    $o_CrSucursalValidadorDP->setUsuarioCreacion($o_propel->UsuarioCreacion);
    return $o_CrSucursalValidadorDP;
  }
}